Summary: Leading World Wide Web server
Name: apache
%define version 1.3.3
Version: %{version}
Release: 1C8
Group: Networking/Daemons

Source: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
#Source1: apache-index.html
#Source2: poweredby.gif
# part of initscripts-cobalt rpm
#Source3: httpd.init
Source4: apache.log
# cobalt specific conf-rpms for each product
#Source5: apache-access.conf
#Source6: apache-httpd.conf
#Source7: apache-srm.conf
Source8: mod_auth_pam.c
Source9: mod_throttle.tar.gz

Patch0: apache_%{version}-redhat.patch
Patch1: apache_%{version}-apxs.patch
Patch2: apache_1.3.1-srvroot.patch
Patch3: apache_%{version}-cobalt.patch

Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-root
#Requires: /etc/mime.types
#Prereq: /sbin/chkconfig, /bin/mktemp
Provides: webserver
Summary(de): Leading World Wide Web-Server
Summary(fr): Serveur Web leader du march<E9>
Summary(tr): Lider WWW taray<FD>c<FD>

%description
Apache is a full featured web server that is freely available, and also
happens to be the most widely used.

%description -l de
Apache ist ein voll funktionsf<E4>higer Web-Server, der kostenlos
erh<E4>ltlich und weit verbreitet ist.

%description -l fr
Apache est un serveur Web complet, disponible librement, et se trouve <EA>tre
aussi le plus utilis<E9> <E0> travers le monde.

%description -l tr
Apache serbest da<F0><FD>t<FD>lan ve <E7>ok kullan<FD>lan yetenekli bir web sunucusudur.

%prep
# first, unpack apache.  We unpack it BELOW a toplevel directory "secureweb"
%setup -q -n apache_%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
cd /usr/src/redhat/BUILD; tar -xzvf /usr/src/redhat/SOURCES/mod_throttle.tar.gz

%build
OPTIM="$RPM_OPT_FLAGS -fomit-frame-pointer -DCOBALT_RAQ_LED" \
LIBS="-lpam -lpwdb -ldl" \
	./configure --prefix=/usr \
	--libexecdir=/usr/lib/apache \
	--sysconfdir=/etc/httpd/conf \
	--serverroot=/etc/httpd \
	--datadir=/usr/doc/httpd \
	--includedir=/usr/include/apache \
	--logfiledir=/var/log/httpd \
	--localstatedir=/var \
	--runtimedir=/var/run \
	--proxycachedir=/var/cache/httpd \
	--enable-module=all \
	--enable-module=rewrite \
	--add-module=$RPM_SOURCE_DIR/mod_auth_pam.c \
	--enable-shared=remain \
	--disable-rule=WANTHSREGEX \
	--activate-module=src/modules/throttle/mod_throttle.o
make

%install
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT

# remove apachectl; we have our own SYSV init stuff
rm -f $RPM_BUILD_ROOT/usr/sbin/apachectl

# rename the html directory
mv -f $RPM_BUILD_ROOT/usr/doc/httpd/htdocs $RPM_BUILD_ROOT/usr/doc/httpd/html

# part of initscripts-cobalt rpm
# install SYSV init stuff
#mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
#install -m755 $RPM_SOURCE_DIR/httpd.init \
#	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

#for I in 0 1 2 6; do
#	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
#	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/K15httpd
#done
#for I in 3 5; do
#	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
#	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/S85httpd
#done

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.log \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -sf ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -sf ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

# do not need to ship the apache test page
#install -m644 $RPM_SOURCE_DIR/apache-index.html \
#        #$RPM_BUILD_ROOT/usr/doc/httpd/html/index.html
#install -m644 $RPM_SOURCE_DIR/poweredby.gif \
#	$RPM_BUILD_ROOT/usr/doc/httpd/html

# cobalt specific conf-rpms for each product
# replace Apache's default config files with our own versions
#install -m644 $RPM_SOURCE_DIR/apache-access.conf \
#	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

#install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
#	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

#install -m644 $RPM_SOURCE_DIR/apache-srm.conf \
#	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# install apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/apache_%{version}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

%clean
rm -rf $RPM_BUILD_ROOT

%post
# initscripts-cobalt should chkconfig
#/sbin/chkconfig --add httpd
[ -f /etc/mime.types ] || exit 0
# safely add .htm to mime types if it is not already there
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /etc/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /etc/mime.types
  types=$(grep "^text/html" /etc/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /etc/mime.types && rm -f $TEMPTYPES

%preun
# initscripts-cobalt should chkconfig
#if [ $1 = 0 ]; then
#   /sbin/chkconfig --del httpd
#fi

%files
%defattr(-,root,root)
# cobalt specific conf-rpms for each product
#%dir /etc/httpd/conf
#%config /etc/httpd/conf/access.conf
#%config /etc/httpd/conf/srm.conf
#%config /etc/httpd/conf/httpd.conf
%config /etc/httpd/conf/magic

/etc/httpd/logs
/etc/httpd/modules
%config /etc/logrotate.d/apache
# part of initscripts-cobalt rpm
#%config /etc/rc.d/init.d/httpd
#%config(missingok) /etc/rc.d/rc3.d/S85httpd
#%config(missingok) /etc/rc.d/rc5.d/S85httpd
#%config(missingok) /etc/rc.d/rc0.d/K15httpd
#%config(missingok) /etc/rc.d/rc1.d/K15httpd
#%config(missingok) /etc/rc.d/rc2.d/K15httpd
#%config(missingok) /etc/rc.d/rc6.d/K15httpd

#%dir /usr/doc/httpd
#%dir /usr/doc/httpd/cgi-bin
#%dir /usr/doc/httpd/html
# do not need to ship the apache test page
#%config(noreplace) /usr/doc/httpd/html/index.html
#/usr/doc/httpd/html/poweredby.gif
%doc /usr/doc/httpd/html/manual
%doc /usr/doc/httpd/icons

/usr/lib/apache
%doc /usr/man
/usr/sbin/ab
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
#/usr/sbin/suexec
/usr/bin

%attr(-,nobody,nobody) %dir /var/cache/httpd
%dir /var/log/httpd

%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs
#/usr/src/apache_%{version}

%changelog
* Tue Mar 30 1999 Will DeHaan <will@cobaltnet.com>
- Added mod_throttle

* Fri Feb 26 1999 Will DeHaan <will@cobaltnet.com>
- update apache.log source to rotate newly named logfiles

* Tue Feb 9 1999 Duncan Laurie <duncan@cobaltnet.com>
- disable suexec

* Sat Jan 9 1999 Sridhar Gopal <gsri@cobaltnet.com>
- add pam support
- modify mod_auth_pam.c to include compat.h (adds prefix ap_ to API functions)

* Sat Jan 9 1999 Sridhar Gopal <gsri@cobaltnet.com>
- integrated cobalt changes with 1.3.3-1 srpm from redhat
- enable suexec
- rpm bitches about chronological order of changes...so s/*/-/

* Tue Dec 22 1998 Duncan Laurie <duncan@cobaltnet.com>
- add mod_rewrite

* Mon Dec 21 1998 Duncan Laurie <duncan@cobaltnet.com>
- built with mod_auth_pam

- Thu Oct 15 1998 Aaron Fosdick <aaron@cobaltnet.com>
- updated to use version 1.3.3
- apache-cobalt patchfile modified to work better with version changes
- no content changed in patchfile, diffs are the same

- Wed Aug 12 1998 Duncan Laurie <duncan@cobaltnet.com>
- fixed web LED blinking code

- Wed Aug 05 1998 Duncan Laurie <duncan@cobaltnet.com>
- upgraded to 1.3.1

- Wed Jul 29 1998 Timothy Stonis <tim@cobaltmicro.com>
-Added LED blinking code.
 
- Tue Jul 28 1998 Kevin K.M. Chiu <kevin@cobaltnet.com>
- 1.3.0-1C3
- Remove unused files and directories

- Fri Jul 3 1998 Timothy Stonis <tim@cobaltnet.com>
-Removing mime.types and putting in another rpm

- Thu Jul 2 1998 Timothy Stonis <tim@cobaltmicro.com>
-Fixing version number to follow Cobalt convention
-Fixing access.conf and srm.conf (more to come)
 
- Wed Jun 10 1998 Aaron Fosdick <aaron@cobaltmicro.com>
- Initial release of 1.3.0 - see configure tags below
- new patch file - standard gendiff on .orig files
- new source paths for httpd.8 htpasswd.8
- added install for htpasswd exec
- for now, .conf files are raq specific - they belong in another rpm
 
- Sat Apr 25 1998 Andrew Bose <andrew@cobaltmicro.com>
- 1.2.5-7 
- removed httpd.init (put into initscripts-cobalt 1.0-5) 

- Sat Feb 28 1998 Timothy Stonis <tim@cobaltmicro.com>
-Added -HUP to log postrotate.

- Tue Feb 24 1998 Timothy Stonis <tim@cobaltmicro.com>
-Added /images/ /home/httpd/html/images/ alias.

- Fri Feb 20 1998 Timothy Stonis <tim@cobaltmicro.com>
-Changed location of error documents so that when server is in secure
 mode where outside people can't get access, they get the pretty 
 authorization required page.`

- Wed Feb 18 1998 Timothy Stonis <tim@cobaltmicro.com>
-Removed webusage alias
-Added /programs/ alias
-Added ErrorDocuments for 404, 401, 500, and 403

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
